﻿<AML>
 <Item type="Method" id="41E44D9CF13D4AE988B72C64F3076658" action="add">
  <comments>2018-01-31--MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			sop_invoice_call_sop
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	-Get Company's Default Sale Account and Service Account
	-Get Sale Order Information according by choosing sale order.
	-Delete Stock Equipment Detail,Service Detail and Service Part Detail.
	-If choosing sale order is for service,sale order information set to the service detail and service part detail.
	-If choosing sale order is for Equipment,sale order information set to Stock Equipment detail.
	
Hooks:
	Type:	Form	:	sop_sale_invoice
	Event:	sop_sale_order ( onChange )

Revisions:
	Rev Date		Modified By			Description
	2017-12-05		MyoThet		    Bring Commercial Invoice No. and Packing List No. for this Sales Order
	2018-01-31      MyoThet         Why the payment term (Net 30 days) is not reflected at Tax Invoice # 81810001 printout?
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();
var thisItem = document.thisItem;

var _sum_tol = 0.0;
var erp_service_account = "";
var erp_sale_account = "";

var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
var result = erp_company_setup.apply();
var result_count = result.getItemCount();
if (result_count > 0) {
    var setup = result.getItemByIndex(0);
    var erp_service_account = setup.getProperty("erp_service_account", "");
    var erp_sale_account = setup.getProperty("erp_sale_account", "");
}

var _gst_percent = top.aras.getItemProperty(document.item, 'pop_gst_percent');
var d_gst_percent = parseFloat(_gst_percent) / 100;

// Get selected SaleOrder Item 
var _sop_sale_order_id = top.aras.getItemProperty(document.item, 'sop_sale_order');
if (_sop_sale_order_id === "") {
    return;
}


var _sop_sale_order_item = myInnovator.getItemById("sop_sale_order", _sop_sale_order_id);
var _sop_sale_order_item = myInnovator.newItem("sop_sale_order", "get");
_sop_sale_order_item.setProperty("id", _sop_sale_order_id);
_sop_sale_order_item = _sop_sale_order_item.apply();

if (_sop_sale_order_item.isError()) {
    return innovator.newError("Invalid Sale Order No.");
}


var classification = _sop_sale_order_item.getProperty("classification", "");
var sop_ship_to = _sop_sale_order_item.getProperty("sop_ship_to", "");
var sop_ship_to_address = _sop_sale_order_item.getProperty("sop_ship_to_address", "");
var sop_invoice_to = _sop_sale_order_item.getProperty("sop_invoice_to", "");
var sop_invoice_to_address = _sop_sale_order_item.getProperty("sop_invoice_to_address", "");
var sop_po_reference = _sop_sale_order_item.getProperty("sop_po_reference", "");
var sop_contract_no = _sop_sale_order_item.getProperty("sop_contract_number", "");

handleItemChange("classification", classification);
handleItemChange("sop_ship_to", sop_ship_to);
handleItemChange("sop_ship_to_address", sop_ship_to_address);
handleItemChange("sop_invoice_to", sop_invoice_to);
handleItemChange("sop_invoice_to_address", sop_invoice_to_address);
handleItemChange("sop_po_reference", sop_po_reference);
handleItemChange("sop_contract_no", sop_contract_no);


/** Begin - clear previous relationships data initially **/
if (classification === "SERVICE") {
    var d_gst_percent = 0;
    var acc_tax_type = 'Zero Rate';

    var fRelationships = thisItem.fetchRelationships("sop_invoice_service_details");
    var gRelationships = thisItem.getRelationships("sop_invoice_service_details");
    var itemCount = gRelationships.getItemCount();
    if (itemCount > 0) {
        for (var i = 0; i < itemCount; i++) {
            var item = gRelationships.getItemByIndex(i);
            thisItem.removeRelationship(item);
        }
    }

    var fRelationships = thisItem.fetchRelationships("sop_invoice_ser_part_detail");
    var gRelationships = thisItem.getRelationships("sop_invoice_ser_part_detail");
    var itemCount = gRelationships.getItemCount();
    if (itemCount > 0) {
        for (var i = 0; i < itemCount; i++) {
            var item = gRelationships.getItemByIndex(i);
            thisItem.removeRelationship(item);
        }
    }

    handleItemChange("acc_account", erp_service_account);
    handleItemChange("pop_gst_percent", d_gst_percent);
    handleItemChange("acc_tax_type", acc_tax_type);
}

if (classification == "EQUIPMENT") {

    var fRelationships = thisItem.fetchRelationships("sop_sale_invoice_details");
    var gRelationships = thisItem.getRelationships("sop_sale_invoice_details");
    var itemCount = gRelationships.getItemCount();
    if (itemCount > 0) {
        for (var i = 0; i < itemCount; i++) {
            var item = gRelationships.getItemByIndex(i);
            thisItem.removeRelationship(item);
        }
    }

    handleItemChange("acc_account", erp_sale_account);
}
/** End - clear previous relationships data initially **/


/** 
 * 2017-12-05 - MyoThet
 * Begin - Bring Commercial Invoice No. and Packing List No. for this Sales Order
 * **/
var commercial_no = "";

var ci_items = myInnovator.newItem("sop_commercial_invoice", "get");
ci_items.setProperty("sop_sale_order", _sop_sale_order_id);
ci_items.setPropertyCondition("sop_sale_order", "eq");
ci_items = ci_items.apply();

if (!ci_items.isError() && ci_items.getItemCount() > 0) {
    var ci_count = ci_items.getItemCount();
    for (var ci_index = 0; ci_index < ci_count; ci_index++) {
        var ci_item = ci_items.getItemByIndex(ci_index);
        var ci_no = ci_item.getProperty("sop_invoice_no", "");

        if (ci_index == ci_count - 1) {
            commercial_no = commercial_no + ci_no;
        } else {
            commercial_no = commercial_no + ci_no + ", ";
        }
    }

    handleItemChange("sop_commercial_no", commercial_no);
}

var packing_list_no = "";

var pl_items = myInnovator.newItem("sop_packing_list", "get");
pl_items.setProperty("sop_order_no", _sop_sale_order_id);
pl_items.setPropertyCondition("sop_order_no", "eq");
pl_items = pl_items.apply();

if (!pl_items.isError() && pl_items.getItemCount() > 0) {
    var pl_count = pl_items.getItemCount();
    for (var pl_index = 0; pl_index < pl_count; pl_index++) {
        var pl_item = pl_items.getItemByIndex(pl_index);
        var pl_no = pl_item.getProperty("sop_packing_list_no", "");

        if (pl_index == pl_count - 1) {
            packing_list_no = packing_list_no + pl_no;
        } else {
            packing_list_no = packing_list_no + pl_no + ", ";
        }
    }

    handleItemChange("sop_packing_list_no", packing_list_no);
}

/** End - Bring Commercial Invoice No. and Packing List No. for this Sales Order **/


/** Start - Service Detail **/
var _service_details_qry = myInnovator.newItem("sop_so_service", "get");
_service_details_qry.setProperty("source_id", _sop_sale_order_id);
var _service_details_items = _service_details_qry.apply();
var _count_ser = _service_details_items.getItemCount();


for (i = 0; i < _count_ser; i++) {
    var ser_details_item = _service_details_items.getItemByIndex(i);
    var stk_id = ser_details_item.getProperty("id", "");
    var stk_item = ser_details_item.getProperty("stk_item", "");
    var stk_qty = ser_details_item.getProperty("stk_qty", "");
    var stk_price = ser_details_item.getProperty("stk_price", "");
    var stk_total_amount = ser_details_item.getProperty("stk_total_amount", "");
    var related_id = ser_details_item.getProperty("related_id", "");

    var _ser_qty = parseFloat(stk_qty);
    var _ser_price = parseFloat(stk_price);
    var _ser_tol_amt = _ser_price * _ser_qty;

    var relationshipItem = myInnovator.newItem("sop_invoice_service_details", "add");
    relationshipItem.setProperty("related_id", related_id);
    relationshipItem.setProperty("stk_item", stk_item);
    relationshipItem.setProperty("stk_qty", stk_qty);
    relationshipItem.setProperty("stk_price", stk_price);
    relationshipItem.setProperty("stk_total_amount", _ser_tol_amt);
    relationshipItem.setProperty("source_id", document.thisItem.getProperty("id"));
    document.thisItem.addRelationship(relationshipItem);
    document.thisItem.setAttribute("isDirty", "1");
    _sum_tol += _ser_tol_amt;

}
/** End - Service Detail **/



/** Start - Service (Part) Details **/
var _service_part_details_qry = myInnovator.newItem("sop_so_service_part", "get");
_service_part_details_qry.setProperty("source_id", _sop_sale_order_id);
var _service_part_details_items = _service_part_details_qry.apply();
var _count_ser_part = _service_part_details_items.getItemCount();


for (i = 0; i < _count_ser_part; i++) {
    var ser_part_details_item = _service_part_details_items.getItemByIndex(i);
    var stk_id = ser_part_details_item.getProperty("id", "");
    var stk_item = ser_part_details_item.getProperty("stk_item", "");
    var stk_qty = ser_part_details_item.getProperty("stk_qty", "");
    var stk_price = ser_part_details_item.getProperty("stk_price", "");
    var stk_total_amount = ser_part_details_item.getProperty("stk_total_amount", "");
    var related_id = ser_part_details_item.getProperty("related_id", "");

    var _ser_part_qty = parseFloat(stk_qty);
    var _ser__part_price = parseFloat(stk_price);
    var _ser_part_tol_amt = _ser__part_price * _ser_part_qty;

    var relationshipItem = myInnovator.newItem("sop_invoice_ser_part_detail", "add");
    relationshipItem.setProperty("related_id", related_id);
    relationshipItem.setProperty("stk_item", stk_item);
    relationshipItem.setProperty("stk_qty", stk_qty);
    relationshipItem.setProperty("stk_price", stk_price);
    relationshipItem.setProperty("stk_total_amount", _ser_part_tol_amt);
    relationshipItem.setProperty("source_id", document.thisItem.getProperty("id"));
    document.thisItem.addRelationship(relationshipItem);
    document.thisItem.setAttribute("isDirty", "1");
    _sum_tol += _ser_part_tol_amt;

}
/** End - Service (Part) Details **/



/** Start - Equipment Details **/
var _sop_details_qry = myInnovator.newItem("sop_sale_order_details", "get");
_sop_details_qry.setProperty("source_id", _sop_sale_order_id);
var _sop_details_items = _sop_details_qry.apply();
var _count = _sop_details_items.getItemCount();

for (i = 0; i < _count; i++) {
    var sop_details_item = _sop_details_items.getItemByIndex(i);
    var stk_id = sop_details_item.getProperty("id", "");
    var stk_code = sop_details_item.getProperty("stk_code", "");
    var stk_description = sop_details_item.getProperty("stk_description", "");
    var stk_location = sop_details_item.getProperty("stk_location", "");
    var stk_category = sop_details_item.getProperty("stk_category", "");
    var stk_sub_category = sop_details_item.getProperty("stk_sub_category", "");
    var stk_uom = sop_details_item.getProperty("stk_uom", "");
    var stk_qty = sop_details_item.getProperty("stk_qty", "");
    var stk_base_qty = sop_details_item.getProperty("stk_base_qty", "");
    var stk_cost = sop_details_item.getProperty("stk_cost", "");
    var stk_base_cost = sop_details_item.getProperty("stk_base_cost", "");
    var stk_price = sop_details_item.getProperty("stk_price", "");
    var stk_total_amount = sop_details_item.getProperty("stk_total_amount", "");
    var stk_operator = sop_details_item.getProperty("stk_operator", "");
    var stk_ratio = sop_details_item.getProperty("stk_ratio", "");
    var stk_used_qty = sop_details_item.getProperty("stk_used_qty", "");

    var _con_qty = parseFloat(stk_qty);
    var _con_price = parseFloat(stk_price);
    var _con_used = parseFloat(stk_used_qty);
    var _diff = _con_qty - _con_used;
    var _new_tol_amt = _con_price * _diff;

    // If difference is greater than zero, add sop_sale_invoice_details
    if (_diff > 0) {
        var relationshipItem = myInnovator.newItem("sop_sale_invoice_details", "add");

        relationshipItem.setProperty("update_id", stk_id);

        var stock_item = myInnovator.newItem("stk_stock_setup", "get");
        stock_item.setProperty("id", stk_code);
        stock_item.setPropertyCondition("id", "eq");
        stock_item = stock_item.apply();
        var stock_item_count = stock_item.getItemCount();

        if (stock_item_count > 0) {
            relationshipItem.setPropertyItem("stk_code", stock_item);
        }
        //	    relationshipItem.setProperty("stk_code",stk_code);
        relationshipItem.setProperty("stk_description", stk_description);
        relationshipItem.setProperty("stk_location", stk_location);
        var l_stk_location = myInnovator.newItem("stk_location", "get");
        l_stk_location.setProperty("id", stk_location);
        l_stk_location.setPropertyCondition("source_id", "eq");
        l_stk_location = l_stk_location.apply();
        var l_stk_location_count = l_stk_location.getItemCount();
        if (l_stk_location_count > 0) {
            relationshipItem.setPropertyItem("stk_location", l_stk_location);
        }


        relationshipItem.setProperty("stk_category", stk_category);
        relationshipItem.setProperty("stk_sub_category", stk_sub_category);
        var l_stk_uom = myInnovator.newItem("stk_uom", "get");
        l_stk_uom.setProperty("id", stk_uom);
        l_stk_uom.setPropertyCondition("source_id", "eq");
        l_stk_uom = l_stk_uom.apply();
        var l_stk_uom_count = l_stk_uom.getItemCount();
        if (l_stk_uom_count > 0) {
            relationshipItem.setPropertyItem("stk_uom", l_stk_uom);
        }
        relationshipItem.setProperty("stk_qty", _diff);
        relationshipItem.setProperty("stk_base_qty", stk_base_qty);
        relationshipItem.setProperty("stk_cost", stk_cost);
        relationshipItem.setProperty("stk_base_cost", stk_base_cost);
        relationshipItem.setProperty("stk_price", stk_price);
        relationshipItem.setProperty("stk_total_amount", _new_tol_amt);
        relationshipItem.setProperty("stk_operator", stk_operator);
        relationshipItem.setProperty("stk_ratio", stk_ratio);
        relationshipItem.setProperty("source_id", document.thisItem.getProperty("id"));
        document.thisItem.addRelationship(relationshipItem);
        document.thisItem.setAttribute("isDirty", "1");
        _sum_tol += _new_tol_amt;
    }
}
/** End - Equipment Details **/

var _gst_amt = _sum_tol * d_gst_percent;
var _tol_amt = _gst_amt + _sum_tol;

handleItemChange("pop_gst_amount", _gst_amt.toFixed(2));
handleItemChange("pop_hide_sub_total", _sum_tol.toFixed(2)); //pop_hide_sub_total
handleItemChange("pop_sub_amount", _sum_tol.toFixed(2));
handleItemChange("pop_total_amount", _tol_amt.toFixed(2));


var sop_customer_phone = _sop_sale_order_item.getProperty("sop_customer_phone", "");
var sop_customer_address = _sop_sale_order_item.getProperty("sop_customer_address", "");
handleItemChange("sop_customer_phone", sop_customer_phone);
handleItemChange("sop_customer_address", sop_customer_address);


/** Start - show credit info for credit customer **/
var customer_id = _sop_sale_order_item.getProperty("sop_customer", "");
var item_customer = myInnovator.newItem("customer", "get");
item_customer.setProperty("id", customer_id);
item_customer.setPropertyCondition("id", "eq");
var customer_result = item_customer.apply();
var customer_count = customer_result.getItemCount();

var iscredit = 0;
if (customer_count > 0) {
    iscredit = customer_result.getProperty("is_credit", "");
    var correction = getFieldByName("sop_iscredit");
    var sop_payment_term = getFieldByName("sop_payment_term");
    var sop_due_date = getFieldByName("sop_due_date");
    handleItemChange("sop_iscredit", 0);
    if (iscredit === "1") {
        if (sop_payment_term) {
            sop_payment_term.disabled = false;
            sop_payment_term.readOnly = false;
            sop_payment_term.style.visibility = "visible";
            sop_payment_term.style.display = "";
        }
        if (sop_due_date) {
            sop_due_date.disabled = false;
            sop_due_date.readOnly = false;
            sop_due_date.style.visibility = "visible";
            sop_due_date.style.display = "";
        }
    }
}
/** End - show credit info for credit customer **/


handleItemChange("sop_invoice_desc", _sop_sale_order_item.getProperty("sop_order_desc", ""));
handleItemChange("sop_invoice_remarks", _sop_sale_order_item.getProperty("sop_order_remarks", ""));
handleItemChange("sop_customer", _sop_sale_order_item.getProperty("sop_customer", ""));

// 2018-01-31--MyoThet
handleItemChange("sop_payment_term", _sop_sale_order_item.getProperty("sop_payment_term", ""));

//update by yyk for currency
handleItemChange("pop_currency", _sop_sale_order_item.getProperty("pop_currency", ""));
handleItemChange("pop_currency_rate", _sop_sale_order_item.getProperty("pop_currency_rate", ""));
handleItemChange("pop_currency_operator", _sop_sale_order_item.getProperty("pop_currency_operator", ""));
var currency_total_amt = 0.00;


// var tabbar = parent.relationships.relTabbar;
// var tabID = tabbar.GetTabId("Invoice Details");
// parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);

parent.onRefresh();]]></method_code>
  <method_type>JavaScript</method_type>
  <name>sop_invoice_call_sop</name>
 </Item>
</AML>